#include "stdafx.h"
#include "TrayTest.h"
#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

constexpr UINT WM_TRAYNOTIFY = WM_USER + 100;

#pragma warning(suppress: 26426)
CTrayNotifyIcon g_TrayIcon1;
#pragma warning(suppress: 26426)
CTrayNotifyIcon g_TrayIcon2;
#pragma warning(suppress: 26426)
CTrayNotifyIcon g_TrayIcon3;


#pragma warning(suppress: 26409 26433 26440 26477)
IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_CREATE()
  ON_COMMAND(ID_HAPPY, &CMainFrame::OnHappy)
  ON_UPDATE_COMMAND_UI(ID_HAPPY, &CMainFrame::OnUpdateHappy)
  ON_COMMAND(ID_SAD, &CMainFrame::OnSad)
  ON_UPDATE_COMMAND_UI(ID_SAD, &CMainFrame::OnUpdateSad)
  ON_COMMAND(ID_ANIMATED, &CMainFrame::OnAnimated)
  ON_UPDATE_COMMAND_UI(ID_ANIMATED, &CMainFrame::OnUpdateAnimated)
  ON_COMMAND(ID_HIDE, &CMainFrame::OnHide)
  ON_UPDATE_COMMAND_UI(ID_HIDE, &CMainFrame::OnUpdateHide)
  ON_COMMAND(ID_SHOW, &CMainFrame::OnShow)
  ON_UPDATE_COMMAND_UI(ID_SHOW, &CMainFrame::OnUpdateShow)
  ON_WM_TIMER()
  ON_WM_DESTROY()
  ON_MESSAGE(WM_TRAYNOTIFY, &CMainFrame::OnTrayNotification)
END_MESSAGE_MAP()

#pragma warning(suppress: 26455)
CMainFrame::CMainFrame() : m_bHappy{true},
                           m_nTimerID{0},
                           m_nTimerCount{0}
{
#pragma warning(suppress: 26446)
  m_Icons[0] = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_HAPPY));
#pragma warning(suppress: 26446)
  m_Icons[1] = LoadIcon(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDR_SAD));
}

#pragma warning(suppress: 26434)
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
  //Let the base class do its thing
  if (__super::OnCreate(lpCreateStruct) == -1)
    return -1;

#pragma warning(suppress: 26446)
  if (!g_TrayIcon1.Create(this, IDR_TRAYPOPUP, _T("Static Tray Icon"), _T("Demo Tray Application"), _T("Static Tray Icon"), 10, CTrayNotifyIcon::BalloonStyle::User, m_Icons[0], WM_TRAYNOTIFY, 0, true, false, false, nullptr, false, false)) //For testing purposes initially creating a tray icon hidden!
  //if (!g_TrayIcon1.Create(this, IDR_TRAYPOPUP, _T("First Tray Icon"), m_hIcons[0], WM_TRAYNOTIFY)) //Uncomment this line and comment out line above if you want to start with a tray icon without animations
  {
    AfxMessageBox(_T("Failed to create tray icon 1"), MB_OK | MB_ICONSTOP);
    return -1;
  }
  //For testing purposes, change the default menu item on the first icon to be the bottom item on the context menu
  g_TrayIcon1.SetDefaultMenuItem(ID_APP_ABOUT, false);

  if (!g_TrayIcon2.Create(this, IDR_TRAYPOPUP2, _T("Animated Tray Icon"), _T("Use the tray context menu to unhide the \"first tray icon\"!"), _T("Animated Tray Icon"), 10, CTrayNotifyIcon::BalloonStyle::Info, m_Icons.data(), 2, 600, WM_TRAYNOTIFY, IDR_TRAYPOPUP2))
  //if (!g_TrayIcon2.Create(this, IDR_TRAYPOPUP2, _T("Second Tray Icon"), _T("Demo Tray Application"), _T("Second Tray Icon"), 10, CTrayNotifyIcon::Info, m_Icons[0], WM_TRAYNOTIFY, IDR_TRAYPOPUP2)) //Uncomment this line and comment out line above if you want a tray icon without animations
  {
    AfxMessageBox(_T("Failed to create tray icon 2"), MB_OK | MB_ICONSTOP);
    return -1;
  }

  //Create the dynamic systray
  if (!CTrayNotifyIcon::GetDynamicDCAndBitmap(&m_TrayIconDC, &m_BitmapTrayIcon))
  {
    AfxMessageBox(_T("Failed to create tray icon 3"), MB_OK | MB_ICONSTOP);
    return -1;
  }
  if (!g_TrayIcon3.Create(this, IDR_TRAYPOPUP3, _T("Dynamic Tray Icon"), _T("This icon demonstrates the dynamic icon animation support of the CTrayNotifyIcon class"), _T("Dynamic Tray Icon"), 10, CTrayNotifyIcon::BalloonStyle::Warning, &m_BitmapTrayIcon, WM_TRAYNOTIFY, IDR_TRAYPOPUP3))
  {
    AfxMessageBox(_T("Failed to create tray icon 3"), MB_OK | MB_ICONSTOP);
    return -1;
  }

  //Also create a timer used for the dynamic tray icons
  m_nTimerID = SetTimer(1, 1000, nullptr);

  return 0;
}

LRESULT CMainFrame::OnTrayNotification(WPARAM wParam, LPARAM lParam)
{
  //Delegate all the work back to the default implementation in CTrayNotifyIcon.
  g_TrayIcon1.OnTrayNotification(wParam, lParam);
  g_TrayIcon2.OnTrayNotification(wParam, lParam);
  g_TrayIcon3.OnTrayNotification(wParam, lParam);
  return 0L;
}

#pragma warning(suppress: 26440)
void CMainFrame::OnHappy()
{
  m_bHappy = !m_bHappy;

  if (m_bHappy)
  {
#pragma warning(suppress: 26446)
    g_TrayIcon1.SetIcon(m_Icons[0]);
    g_TrayIcon1.SetTooltipText(_T("I'm Happy!"));
  }
  else
  {
#pragma warning(suppress: 26446)
    g_TrayIcon1.SetIcon(m_Icons[1]);
    g_TrayIcon1.SetTooltipText(_T("I'm Sad!"));
  }
}

#pragma warning(suppress: 26429)
void CMainFrame::OnUpdateHappy(CCmdUI* pCmdUI)
{
  if (g_TrayIcon1.UsingAnimatedIcon())
#pragma warning(suppress: 26486)
    pCmdUI->Enable(FALSE);
  else
#pragma warning(suppress: 26486)
    pCmdUI->SetCheck(m_bHappy);
}

void CMainFrame::OnSad()
{
  OnHappy();
}

#pragma warning(suppress: 26429)
void CMainFrame::OnUpdateSad(CCmdUI* pCmdUI)
{
  if (g_TrayIcon1.UsingAnimatedIcon())
#pragma warning(suppress: 26486)
    pCmdUI->Enable(FALSE);
  else
#pragma warning(suppress: 26486)
    pCmdUI->SetCheck(!m_bHappy);
}

#pragma warning(suppress: 26440)
void CMainFrame::OnAnimated()
{
  if (g_TrayIcon1.UsingAnimatedIcon())
  {
#pragma warning(suppress: 26446)
    g_TrayIcon1.SetIcon(m_Icons[0]);
  }
  else
  {
    g_TrayIcon1.SetIcon(m_Icons.data(), 2, 500);
  }
}

#pragma warning(suppress: 26429)
void CMainFrame::OnUpdateAnimated(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->SetCheck(g_TrayIcon1.UsingAnimatedIcon());
}

#pragma warning(suppress: 26434)
void CMainFrame::OnTimer(UINT_PTR nIDEvent)
{
  if (m_nTimerID == nIDEvent)
  {
    //Draw into the tray icon bitmap
    CString sNum;
    sNum.Format(_T("%d"), m_nTimerCount);
    m_TrayIconDC.SetBkMode(TRANSPARENT);
    m_TrayIconDC.SetTextColor(RGB(255,255,255));
    const int nWidth{m_TrayIconDC.GetDeviceCaps(LOGPIXELSX)};
    const int nHeight{m_TrayIconDC.GetDeviceCaps(LOGPIXELSY)};
    CRect r;
    r.top = 0;
    r.left = 0;
    r.right = nWidth;
    r.bottom = nHeight;
    CBrush blackBrush;
    blackBrush.CreateStockObject(BLACK_BRUSH);
    m_TrayIconDC.FillRect(&r, &blackBrush);
    m_TrayIconDC.TextOut(0, 0, sNum);

    //Update it
    g_TrayIcon3.SetIcon(&m_BitmapTrayIcon);

    //Increment the count, ready for the next time around
    m_nTimerCount++;
    if (m_nTimerCount == 100)
      m_nTimerCount = 0;
  }
}

#pragma warning(suppress: 26434)
void CMainFrame::OnDestroy()
{
  if (m_nTimerID)
  {
    KillTimer(m_nTimerID);
    m_nTimerID = 0;
  }

  //Let the parent class do its thing
  __super::OnDestroy();
}

#pragma warning(suppress: 26440)
void CMainFrame::OnHide()
{
  g_TrayIcon1.Hide();
}

#pragma warning(suppress: 26429)
void CMainFrame::OnUpdateHide(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->Enable(!g_TrayIcon1.IsHidden());
}

#pragma warning(suppress: 26440)
void CMainFrame::OnShow()
{
  g_TrayIcon1.Show();
}

#pragma warning(suppress: 26429)
void CMainFrame::OnUpdateShow(CCmdUI* pCmdUI)
{
#pragma warning(suppress: 26486)
  pCmdUI->Enable(g_TrayIcon1.IsHidden());
}
