#include "NTray.h"


class CMainFrame : public CFrameWnd
{
public:
//Constructors / Destructors
  CMainFrame();
  CMainFrame(const CMainFrame&) = delete;
  CMainFrame(CMainFrame&&) = delete;
  ~CMainFrame() = default; //NOLINT(modernize-use-override)

//Methods
  CMainFrame& operator=(const CMainFrame&) = delete;
  CMainFrame& operator=(CMainFrame&&) = delete;

protected:
//Member variables
  std::array<HICON, 2> m_Icons;
  bool m_bHappy;
  CDC m_TrayIconDC;
  CBitmap m_BitmapTrayIcon;
  UINT_PTR m_nTimerID;
  int m_nTimerCount;

//Message handlers
  afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
  afx_msg void OnHappy();
  afx_msg void OnUpdateHappy(CCmdUI* pCmdUI);
  afx_msg void OnSad();
  afx_msg void OnUpdateSad(CCmdUI* pCmdUI);
  afx_msg void OnAnimated();
  afx_msg void OnUpdateAnimated(CCmdUI* pCmdUI);
  afx_msg void OnTimer(UINT_PTR nIDEvent);
  afx_msg void OnDestroy();
  afx_msg void OnUpdateShow(CCmdUI* pCmdUI);
  afx_msg void OnShow();
  afx_msg void OnUpdateHide(CCmdUI* pCmdUI);
  afx_msg void OnHide();
  afx_msg LRESULT OnTrayNotification(WPARAM wParam, LPARAM lParam);

  DECLARE_MESSAGE_MAP()
  DECLARE_DYNCREATE(CMainFrame)
};
